#!/usr/bin/perl

$base_dir = '/home/lanttis/dev/elib/src/zebra/records/';

use MARC::Record;
use MARC::File::USMARC;

if($ARGV[0] eq "--show") {
	$type = 'show';
} elsif ($ARGV[0] eq "--replace") {
	$type = 'replace';
} else {
	die "Unsupported argument: $ARGV[0]\n";
}

opendir(DIR, $base_dir) || die "cannot opendir $base_dir: $!";
@dots = grep { -f "$base_dir/$_" } readdir(DIR);
closedir DIR;

foreach (@dots)
{
 	$file = MARC::File::USMARC->in("$base_dir/$_") or die "$!\n";
	while ($MARC = $file->next())
	{
	 	$field = $MARC->field('020');
		if ($field) {
			$old_string = $field->as_string('a');
			$new = $field->as_string('a');
			$new =~ s/[^0-9Xx]//g;
		} else {
			$old_string = "<none>";
			$new = "<none>";
		}
		if ($type eq 'show') {
			print "Pending (in $_): ".$old_string." => $new\n";
		} elsif ($type eq 'replace') {
			if($field) {
				if($new ne $old_string) {
					$field->update('a' => $new);
					open OUT, ">".$base_dir.'/'.$_ || die "cannot open file $_: $!\n";
					print OUT $MARC->as_usmarc();
					close OUT;
				}
			}
			print "Replaced (in $_): ".$old_string." => $new\n";
		}			
	}
}
